田草博客

互联网田草博客


网友交流QQ群:11740834 需注明申请加入原因

微信 公众号:ByCAD

邮箱:tiancao1001x126.com
ByCAD,微信公众号
首页 | 普通 | 电脑 | AutoCAD | VB/VB.NET | FLash | 结构 | 建筑 | 电影 | BIM | 规范 | 软件 | ID
-随机-|-分布-
-博客论坛-|-﨣﨤﨧﨨-
-网站导航-|-规范下载-
-BelovedFLash欣赏-

用户登陆
用户:
密码:
 

站点日历
73 2024 - 4 48
 123456
78910111213
14151617181920
21222324252627
282930


站点统计

最新评论



隐藏日志,无权浏览 隐藏日志,无权浏览
未知 Select polyline segment   [ 日期:2023-12-19 ]   [ 来自:转帖 ]  HTML
https://forums.augi.com/showthread ... lect-polyline-segment
程序代码:

    Public Sub SelectNestedPolyline()
            Dim doc As Document = Application.DocumentManager.MdiActiveDocument
            Dim db As Database = doc.Database
            Dim ed As Editor = doc.Editor

            ' Prompt the user to select a polyline segment.
            Dim options As New PromptNestedEntityOptions(vbLf & "Select a polyline segment: ")
            options.AllowNone = False
            Dim result As PromptNestedEntityResult = ed.GetNestedEntity(options)
            If result.Status <> PromptStatus.OK Then
                Return
            End If

            ' If the selected entity is a polyline.
            If result.ObjectId.ObjectClass.Name = "AcDbPolyline" Then

                ' Start a transaction to open the selected polyline.
                Using tr As Transaction = db.TransactionManager.StartTransaction()

                    ' Transform the picked point from current UCS to WCS.
                    Dim wcsPickedPoint As Point3d = result.PickedPoint.TransformBy(ed.CurrentUserCoordinateSystem)

                    ' Open the polyline.
                    Dim pline As Polyline = DirectCast(tr.GetObject(result.ObjectId, OpenMode.ForRead), Polyline)

                    ' Get the closest point to picked point on the polyline.
                    ' If the polyline is nested, it's needed to transform the picked point using the 
                    ' the transformation matrix that is applied to the polyline by its containers.
                    Dim pointOnPline As Point3d = _
                        If(result.GetContainers().Length = 0, _
                            pline.GetClosestPointTo(wcsPickedPoint, False), _
                            pline.GetClosestPointTo(wcsPickedPoint.TransformBy(result.Transform.Inverse()), False))

                    ' Get the selected segment index.
                    Dim segmentIndex As Integer = CInt(pline.GetParameterAtPoint(pointOnPline))
                    ed.WriteMessage(vbLf & "Selected segment index: {0}", segmentIndex)
                    tr.Commit()
                End Using
            End If
        End Sub




暂时没有评论
发表评论 - 不要忘了输入验证码哦!
作者: 用户:  密码:   注册? 验证:  防止恶意留言请输入问题答案:2*9=?  
评论:

禁止表情
禁止UBB
禁止图片
识别链接
识别关键字

字体样式 文字大小 文字颜色
插入粗体文本 插入斜体文本 插入下划线
左对齐 居中对齐 右对齐
插入超级链接 插入邮件地址 插入图像
插入 Flash 插入代码 插入引用
插入列表 插入音频文件 插入视频文件
插入缩进符合
点击下载按钮 下标 上标
水平线 简介分割标记
表  情
 
Tiancao Blog All Rights Reserved 田草博客 版权所有
Copyright ©